<?php
	
/* Special fields of Slides & Transitions and Slide defaults form (handled by Cu3erHelper::generateHTML method)
 *
 * $special_fields = array(
	'field name' => array(
		'type [type of the field]' => ['colorpicker','genericlist(dropdown)','radiolist','checkbox','image','textarea'],
		'value [value(s) of the field]' => [string, array],
		'label [label(s) of the field if you want it to be different from value, (eg <option value="10">ten</option>)]' => [string, array],
		'display_name [displaying name of the field]' => [true, false],
		'uncheck_value [requested value if field is checkbox and unchecked (eg: 'no' or false)]' => [string],
	)
 * )	
 * If a field is not in special fields array it is generated into <input type="text" value=".." /> element automatically
 */

	$special_fields = array(
		'color' => array(
			'type' => 'colorpicker',
		),
		'target' => array (
			'type' => 'genericlist',
			'value' => array(
				'_self',
				'_blank',
				'_parent',
				'_top',
				),
		),
		'dtarget' => array (
			'type' => 'genericlist',
			'value' => array(
				'_self',
				'_blank',
				'_parent',
				'_top',
				),
		),
		'type' => array(
			'type' => 'radiolist',
			'value' => array(
				'3D',
				'2D',
				),
		),
		'type2D' => array(
			'type' => 'genericlist',
			'value' => array(
				'slide',
				'fade',
				),
		),
		'flipAngle' => array(	
			'type' => 'genericlist',
			'value' => array(
				'180',
				'90',
				),
		),
		'flipOrder' => array(
			'type' => 'genericlist',
			'value' => array(
				'0',
				'315',
				'270',
				'225',
				'180',
				'135',
				'90',
				'45',
				),
			'label' => array(
				'From Left to Right',
				'From Top-Left to Bottom-Right',
				'From Top to Bottom',
				'From Top-Right to Bottom-Left',
				'From Right to Left',
				'From Bottom-Right to Top-Left',
				'From Bottom to Top',
				'From Bottom-Left to Top-Right',
			),
		),
		'flipOrderFromCenter' => array(
			'type' => 'genericlist',
			'value' => array(
				'true',
				'false',
				),
		),
		'flipDirection' => array(
			'type' => 'checkbox',
			'value' => array(
				'up',
				'down',
				'left',
				'right',
				),
		),
		'flipColor' => array(
			'type' => 'colorpicker',
		),
		'flipShader' => array(
			'type' => 'genericlist',
			'value' => array(
				'flat',
				'none',
				),
		),
		'flipEasing' => array(
			'type' => 'genericlist',
			'value' => array(
				'Sine.easeOut',
				'Sine.easeInOut',
				'Sine.easeIn',
				'Bounce.easeOut',
				'Bounce.easeInOut',
				'Bounce.easeIn',
				'Elastic.easeOut',
				'Elastic.easeInOut',
				'Elastic.easeIn',
				'Expo.easeOut',
				'Expo.easeInOut',
				'Expo.easeIn',
			),
		),
		'seo_show_image' => array(
			'type' => 'checkbox',
			'value' => array(
				'yes'
				),
			'uncheck_value' => 'no',
		),
		'seo_show_heading' => array(
			'type' => 'checkbox',
			'value' => array(
				'yes'
				),
			'uncheck_value' => 'no',
		),
		'seo_show_paragraph' => array(
			'type' => 'checkbox',
			'value' => array(
				'yes'
				),
			'uncheck_value' => 'no',
		),
		'seo_show_caption' => array(
			'type' => 'checkbox',
			'value' => array(
				'yes'
				),
			'uncheck_value' => 'no',
		),
	);

	// Special fields of Slides & Transitions (handled by Cu3erHelper::generateHTML method)	
	$special_fields_slide = array(
		'image' => array(
			'type' => 'image',
			'display_name' => false,		
		),
		'use_image' => array(
			'type' => 'genericlist',
			'value' => array(
				'yes',
				'no'
				),
		),
		'published' => array(
			'type' => 'checkbox',
			'value' => array(
				1,
			),
			'label' => array(
				'published',
			),
			'display_name' => false,
		),
	);

	// Special fields of Slide Defaults (handled by Cu3erHelper::generateHTML method)	
	$special_fields_default = array(
		'salign_pos' => array(
			'type' => 'genericlist',
			'value' => array(
				'TL',
				'TC',
				'TR',
				'ML',
				'MC',
				'MR',
				'BL',
				'BC',
				'BR',
				),
			'label' => array(
				'Top-Left',
				'Top-Center',
				'Top-Right',
				'Middle-Left',
				'Middle-Center',
				'Middle-Right',
				'Bottom-Left',
				'Bottom-Center',
				'Bottom-Right',
			),
		),
		'type2D' => array(
			'type' => 'genericlist',
			'value' => array(
				'slide',
				'fade',
				),
		),
	);
	
	// Merging with common special fields array
	$special_fields_slide += $special_fields;
	$special_fields_default += $special_fields;

	// Parameters which don't appear in the settings form	
	$hidden_fields = array(	'id', '_tbl', '_tbl_key', 
				'_db', '_errors', 'modified', 'position',
				'align_pos', 'x', 'y', 'scalex', 'scaley',
				'salign_pos', 'sx', 'sy', 'swidth', 'sheight',
				'slideshow_id', 'transparent', 'ordering');

	// Parameters which don't appear in the settings form of slide defaults	
	$hidden_fields_default = array(	'id', '_tbl', '_tbl_key', 
				'_db', '_errors', 'modified', 'position',
				'align_pos', 'x', 'y', 'scalex', 'scaley',
				'slideshow_id', 'ordering', 'corner_tl', 
				'corner_tr', 'corner_bl', 'corner_br', 
				'thumb_width', 'thumb_height', 'transparent');

	// Parameter groups (first element's name => group name) for parameter separation
	$field_groups = array(
		'image' => 'slide image',
		'duration' => 'slide settings',
		'heading' => 'description box',
		'type' => 'transition settings',
		'seo_show_image' => 'SEO'
	);

	// Parameter groups for slide defaults (first element's name => group name) for parameter separation
	$field_groups_default = array(
		'swidth' => 'slides size',
		'salign_pos' =>	'Slides align and offset',
		'duration' => 'slide settings',
		'dlink' => 'description box',
		'type' => 'transition settings',
		'seo_show_image' => 'SEO'
	);

	// Parameters for generate_slide.php query (parameter name => query variable name)
	$generate_slide_fields = array(
		'image' => 'image',
		'x' => 'image_x',
		'y' => 'image_y',
		'scaleX' => 'image_scaleX',
		'scaleY' => 'image_scaleY',
		'align_pos' => 'image_pos',
		'corner_TL' => 'slide_TL',
		'corner_TR' => 'slide_TR',
		'corner_BL' => 'slide_BL',
		'corner_BR' => 'slide_BR',
		'color' => 'slide_color',
		'swidth' => 'slide_width',
		'sheight' => 'slide_height',
		'thumb_width' => 'thumb_width',
		'thumb_height' => 'thumb_height',
		'use_image' => 'use_image'
	);



?>