<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: cu3erxmlconv.class.php 2011-04-12 05:17:53 svn $
 * @author MADEBYPLAY
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class Cu3erXMLConv {

	// The destiantion array of XML2Array method
	var $xml_array = array();

	// Actual tag in XML2Array method
	var $tag = null;

	// PHP XML object
	var $xml_reader = null;

	/**
	 * Constructor
	 *
	 * @param string	$XMLString XML string
	 */
	function Cu3erXMLConv($XMLString) {

		$this->xml_reader = new XMLReader();
		$this->xml_reader->XML($XMLString);
	}

	/**
	 * XML to array converter method
	 *
	 * @return array $xml_array
	 */
	function XML2Array() { 

		$current = &$this->xml_array; 
 
		while($this->xml_reader->read()){							
			unset($result);
			switch($this ->xml_reader->nodeType){
				case 1:
					$this->tag = $this->xml_reader->name;	
					if($this ->xml_reader->depth > 0) $current = &$parent[$this->xml_reader->depth - 1];	
				
					if($this->xml_reader->hasAttributes){
						$attributeCount = $this->xml_reader->attributeCount; 
					
						for($i = 0; $i < $attributeCount; $i++){
							$this->xml_reader->moveToAttributeNo($i);
							$result['attr'][$this->xml_reader->name] = $this->xml_reader->value;
						}

						$this->xml_reader->moveToElement();
					}else{
						$result = '';
					}
				
					if(!@is_array($current[$this->tag]))
						$current[$this->tag] = $result;
					elseif(!@is_array($current[$this->tag][0]))
						$current[$this->tag] = array($current[$this->tag], $result);
					else
						$current[$this->tag][] = $result;

					if(!@is_array($current[$this->tag][0]))
						$parent[$this->xml_reader->depth] = &$current[$this->tag];
					else
						$parent[$this->xml_reader->depth] = &$current[$this->tag][count($current[$this->tag]) - 1];
					break;
				case 3:
					$current[$this->tag]['value'] = $this->xml_reader->value;
					$this->xml_reader->read();
					break;
				case 4:
					$current[$this->tag]['value'] = $this->xml_reader->value;
					$this->xml_reader->read();
					break;
				default:
					break;
			}
		}
		return $this->xml_array;
	}

	/**
	 * Array to XML converter method
	 *
	 * @return string XML string
	 */
	function array2XML($array) {
		foreach($array as $key=>$value) {
			if(is_array($value)) {
				if($key !== '@attributes' && $key !== 'vle') {
					if(is_numeric($key)) {
						$childs = '';
						$children = Cu3erXMLConv::array2XML($value);
					} else {
						$childs .= Cu3erXMLConv::array2XML($value);
						$childs = ($childs != '') ? $childs : 'empty';
					}
				}
			} else {
				$childs = ($value != '') ? $value : 'empty';
			}
			if($childs != '') {
				$attributes = Cu3erXMLConv::getAttributes($array[$key], $key);
				$vle = Cu3erXMLConv::getNodeValue($array[$key]);
				$attributes[$key] = ($attributes[$key] != '') ? ' ' . $attributes[$key] : '';
				if($key !== 'vle' && $key !== '@attributes') {
					if($childs == 'empty') {
						if($vle != '') {
							$xml .= '<'. $key . $attributes[$key] .'>' . $vle . '</'. $key .'>';
						} else {
							$xml .= '<'. $key . $attributes[$key] .' />';
						}
					} else {
						$xml .= '<'. $key . $attributes[$key] .'>' . $vle . $childs . '</'. $key .'>';
					}
					unset($attributes[$key], $childs);
				}
			}
			if($children != '') {
				$xml .= $children;
				$children = '';
			}
		}
		return $xml;
	}

	/**
	 * XML array attribute getter method
	 *
	 * @param array		$array XML array
	 * @param string	$parent key of parent array
	 * @return array attributes array
	 */
	function getAttributes($array, $parent) {
		if (is_array($array)) {		
			foreach($array as $key=>$value) {
				if($key === '@attributes') {
					foreach($value as $k=>$v) {
						$attr[] = $k . '="' . $v . '"';
					}
					$attributes[$parent] = implode(" ", $attr);
					unset($attr);
				}
			}
		} else {
			$attributes = null;
		}

		return $attributes;
	}

	/**
	 * XML node value getter method
	 *
	 * @param array		$array XML array
	 * @return string node value
	 */
	function getNodeValue($array) {
		if (is_array($array)) {		
			foreach($array as $key=>$value) {
				if($key === 'vle') {
					return $value;
				}
			}
		} else {
			return '';
		}
	}

}
