<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: slideshow.php 2011-04-12 05:17:53 svn $
 * @author MADEBYPLAY
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

// Include Slideshow table
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

class Cu3erModelSlide extends JModel {

	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct() {
		parent::__construct();
	}    	

	/**
	 * Slide list getter method
	 *
	 * @access public
	 * @param string $table_name name of the slide table
	 * @param int	 $id ID of a table row
	 * @return array array of slideshows
	 */
	function getData($table_name, $id = null, $empty = false) {

		if ($id == null) $id = JRequest::getVar('cid');
		$row = & JTable::getInstance($table_name, 'Table');
		if(!$empty) $row->load($id);
		return $row;
	}

	/**
	 * Slideshow settings saver method
	 *
	 * @access	public
	 * @param	boolean	 $preview true if component generates preview (no saving to db)	
	 */
	function save($preview = false) {

		$mainframe = &JFactory::getApplication();

		// Getting slide and default tables
		$row = & JTable::getInstance('Cu3erSlide', 'Table');
		$default = & JTable::getInstance('Cu3erDefault', 'Table');

		$post = JRequest::get('post');

		$slideshow_id = JRequest::getInt('slideshow_id');
		
		$slideshow = & JTable::getInstance('Cu3erSlideshow', 'Table');
		$slideshow->load($slideshow_id);
		$hasJS = false;
		$path = '';
		if($this->hasJavaScript($slideshow->images_folder)) {
			$hasJS = true;
			$path = $this->getFallbackPath($slideshow->images_folder);
		}

		// setting ordering parameter of slide (last position if null)
		$post['ordering'] = ($post['ordering'] != null)?($post['ordering']):($this->getLastSlideOrdering($slideshow_id)+1);

		// loading slide defaults by slideshow ID
		$default->load($slideshow_id);
		// handling posted variables
		foreach ($post as $name => $value) {
			if (is_array($value)) {
				// eg. up,down,left,right value
				$post[$name] = implode(",", $value);
			}			

			// if the posted slide parameter exists as slide default and that has the same value
			// NULL value will be stored to that specific slide parameter
			if (isset($default->$name) && ($default->$name == $value) && $name != 'slideshow_id' && $name != 'id') {
				$post[$name] = NULL;			
			}
		}
		if($hasJS) {
			$data = array(
				'image' => $slideshow->images_folder . '/' . $post['image'],
				'image_x' => ($post['x'] != '') ? $post['x'] : $default->x,
				'image_y' => ($post['y'] != '') ? $post['y'] : $default->y,
				'image_scaleX' => ($post['scaleX'] != '') ? $post['scaleX'] : $default->scaleX,
				'image_scaleY' => ($post['scaleY'] != '') ? $post['scaleY'] : $default->scaleY,
				'image_pos' =>  ($post['align_pos'] != '') ? $post['align_pos'] : $default->align_pos,
				'slide_TL' => $default->corner_TL,
				'slide_TR' => $default->corner_TR,
				'slide_BL' => $default->corner_BL,
				'slide_BR' => $default->corner_BR,
				'slide_color' => ($post['color'] != '') ? $post['color'] : $default->color,
				'slides_width' => $default->swidth,
				'slides_height' => $default->sheight,
				'slideshow_id' => $slideshow_id,
				'slide_id' => ($post['id'] != '') ? $post['id'] : '',
				'use_image' => $post['use_image']
			);
			$data['slide_color'] = str_replace(array('#', '0x'), array('', ''), $data['slide_color']);
			if($default->thumb_width != '' && $default->thumb_height != '' && $default->thumb_height > 0) {
				$data['thumb_width'] = $default->thumb_width;
				$data['thumb_height'] = $default->thumb_height;
			}
			$this->generator($data);
		}
		// if task is not preview
		if (!$preview) {

			require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'slide_fields.php');

			foreach ($special_fields as $field => $attr) {
				// handling unchecked checkbox values for appropriate database storage
				if ($attr['type'] == 'checkbox' && !JRequest::getVar($field)) {
					$row->{$field} = (isset($attr['uncheck_value']))?$attr['uncheck_value']:0;		
				}
			}

			$row->checkin();
			// binding, checking and storing posted variables to database
			if (!$row->bind($post) || !$row->check() || !$row->store()) {
				$mainframe->redirect('index.php?option=com_cu3er&view=slide&cid='.$row->id, $row->getError(), 'error');
			}

			$row->checkin();
		}

		// cache cleanup
		$cache = &JFactory::getCache('com_cu3er');
		$cache->clean();

		// managing page redirection according the controller's task
		switch (JRequest::getCmd('task')) {
		        case 'apply':
        		        $msg = JText::_('Changes to Slide saved');
        		        $link = 'index.php?option=com_cu3er&view=slide&cid='.$row->id;
        		        break;
        		case 'saveAndNew':
		                $msg = JText::_('Slide Saved') . ' - ' . JText::_('New Slide editing');
                		$link = 'index.php?option=com_cu3er&view=slide&empty=1&slideshow_id='.JRequest::getInt('slideshow_id');
                		break;
				case 'preview':
						$msg = JText::_('Preview Generated');
		                break;
		        case 'save':
		        default:
                		$msg = JText::_('Slide Saved');
		                $link = 'index.php?option=com_cu3er&view=slides&cid='.JRequest::getInt('slideshow_id');
		                break;
	        }
		
	    	require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'lib'.DS.'cu3erfile.class.php');
		
		if ($preview) {

			// setting preview array (see Cu3erXML class)
			$prev_array = array(
				'name' => 'slides', 
				'key' => $post['id'], 
				'params' => $post,
			);
			
			// generation of the CU3ER-preview.xml file
			if (!Cu3erFile::generateXMLFile($slideshow_id, null, $prev_array)) {
				$msg = 'Unable to write CU3ER-preview.xml file';
			}

			//echo $msg;

		} else { 
			// generation of the CU3ER-generated.xml file
			if (!Cu3erFile::generateXMLFile($slideshow_id)) {
				$msg = 'Unable to write CU3ER-generated.xml file';		
			}
			// calling page redirection
			$mainframe->redirect($link, $msg);
		}
		
	}

	function getLastSlideOrdering($slideshow_id) {
		$db = & JFactory::getDBO();
		$query = 	"SELECT MAX(ordering) FROM #__cu3er__slides ".
				"WHERE slideshow_id = {$slideshow_id} ";

		$db->setQuery($query);
		return (int)$db->loadResult();		
	}

	/**
	 * Fallback image position calculator method
	 *
	 * @access	public
	 * @param	int	 $slide_id 	ID of slide
	 * @param	int	 $slideshow_id	ID of slideshow
	 */
	function getFallbackImgPos($slide_id = '', $slideshow_id) {
		$db = & JFactory::getDBO();
		if($slide_id != '') {
			$query = 	"SELECT COUNT(id) FROM #__cu3er__slides ".
					"WHERE slideshow_id = {$slideshow_id} ".
					"AND published = 1 " .
					"AND ordering < " .
					"(SELECT ordering FROM #__cu3er__slides WHERE id = {$slide_id})";
		} else {
			$query = 	"SELECT COUNT(id) FROM #__cu3er__slides ".
					"WHERE slideshow_id = {$slideshow_id} ".
					"AND published = 1";
		}
		//echo $query;
		$db->setQuery($query);
		return ((int)$db->loadResult())+1;
	}

	/**
	 * Remote slide image generator caller (proxy) method
	 * 
	 * @access	public
	 * @param	string	 $generator_URL	URL of the slide image generator PHP
	 * @param	string	 $query			query string of the PHP calling
	 */
	function callSlideGenerator($generator_URL, $query) {
		jimport('joomla.filesystem.file');

		// reading the output of the slide image generator php as string
		if($query['use_image'] == 'no') {
			$query['image'] = 'http://getcu3er.com/img/blank.png';
		}
		if($query['thumb_width'] == '0') {
			unset($query['thumb_width'], $query['thumb_height']);
		}
		if($query['slide_width'] != '') {
			$query['slides_width'] = $query['slide_width'];
			unset($query['slide_width']);
		}
		if($query['slide_height'] != '') {
			$query['slides_height'] = $query['slide_height'];
			unset($data['slide_height']);
		}
		$data = JFile::read($generator_URL . '?' . http_build_query($query));
		//echo $generator_URL . '?' . http_build_query($query);
		// decoding JSON string into array
		$data = json_decode(stripslashes($data), true);
		//echo $data;

		// setting additional variables
		$data['slide_id'] = $query['slide_id'];
		$data['slideshow_id'] = $query['slideshow_id'];
		$data['preview'] = $query['preview'];
		// calling image saver method
		return $this->saveRemoteImages($data);
	}

	/**
	 * Remote image saver method
	 *
	 * @access	public
	 * @param	array	 $data array of image data
	 */
	function saveRemoteImages($data) {
		
		jimport('joomla.filesystem.folder');

		// beginning of the method's response (JSON) string
		$msg = '{"success":';
		$ok = false;

		$slideshow_id = $data['slideshow_id'];

		$slide_id = $data['slide_id'];
		$slideshow_img_dir = JPATH_SITE.DS.(JComponentHelper::getParams('com_media')->get('image_path')).DS.'CU3ER'.DS.$slideshow_id;

		// creating fallback directory if not exists
		if (!JFolder::exists($slideshow_img_dir . DS . 'fallback')) {
			JFolder::create($slideshow_img_dir . DS . 'fallback');
		}
		// method returns the absolute position of the specic fallback image (only published slides)
		$num = $this->getFallbackImgPos($slide_id, $slideshow_id);

		// setting up image and thumbnail paths
		$img = $slideshow_img_dir . DS . 'fallback' . DS . 'slide' . $num . '.png';
		$thumb = $slideshow_img_dir . DS . 'fallback' . DS . 'thumb_slide' . $num . '.png';		
		
		$img_remote = $data['url_slide'];
		$thumb_remote = $data['url_thumb'];

		// making backup image if image exists and task is preview
		if (JFile::exists($img) && $data['preview']) {
			JFile::copy($img, $img . '.bak');
		}

		// making backup thumbnail image if exists and task is preview
		if ($thumb_remote !== false && JFile::exists($thumb) && $data['preview']) {
			JFile::copy($img, $img . '.bak');
		}		
		
		// reading remote image file
		$img_file = JFile::read($img_remote);

		// saving image file and handling error messages
		if ($img_file === false) {
			$error = JText::_('Cannot find or read remote image file') . ': ' . $img_remote;		
		} elseif (!JFile::write($img, $img_file)) {
			$error = JText::_('Cannot write local image file') . ': ' . $img;		
		} else {
			$ok = true;	
		}

		// saving thumbnail file (if needed) and handling error messages
		if ($thumb_remote != '') {
			$thumb_file = JFile::read($thumb_remote);
			
			if ($thumb_file === false) {
				$error = JText::_('Cannot find or read remote image file') . ': ' . $thumb_remote;
			} elseif (!JFile::write($thumb, $thumb_file)) {
 				$error = JText::_('Cannot write local image file') . ': ' . $thumb;
			} else {
				$ok = true;
			}
		}
		
		// generation of method's response JSON string
		return $msg . (($ok)?('"1"}'):('"0", "error":"'.$error.'"}'));
		
	}

	/**
	 * Fallback image counter method
	 *
	 * @access	public
	 * @param	int	$slideshow_id ID of the slideshow
	 * @return 	int 	number of fallback images
	 */
	function getFallbackImgNum($slideshow_id) {
		$db = & JFactory::getDBO();

		$query = 	"SELECT COUNT(id) FROM #__cu3er__slides ".
				"WHERE slideshow_id = {$slideshow_id} ".
				"AND published = 1 ";

		$db->setQuery($query);
		return (int)$db->loadResult();	
	}

	/**
	 * Slide fallback image restoring method
	 *
	 * @access	public
	 * @return 	boolean true if success
	 */
	function restoreSlideImages() {

		jimport('joomla.filesystem.file');
		$slideshow_id = JRequest::getInt('slideshow_id');
		$msg = '{"success":';
		$error = 0;
		
		// getting the number of fallback image by slide ID
		$img_num = $this->getFallbackImgNum($slideshow_id);

		$img_path = JPATH_SITE.DS.(JComponentHelper::getParams('com_media')->get('image_path')).DS.'CU3ER'.DS.$slideshow_id.DS.'fallback';	

		// cycling thru every possible fallback image		
		for ($slide_num = 1; $slide_num < $img_num+1; $slide_num++) {

			// setting image path and filenames
			$img_bak = $img_path.DS.'slide'.$slide_num.'.png.bak';
			$thumb_bak = $img_path.DS.'thumb_slide'.$slide_num.'.png.bak';

			// renaming slideN.png.bak file to slideN.png
			if (JFile::exists($img_bak)) {
				if (!JFile::move($img_bak, $img_path.DS.'slide'.$slide_num.'.png')) {
					$error = JText::_('Cannot restore image file') . ': ' . $img_bak;			
				}
			}

			// renaming thumb_slideN.png.bak file to thumb_slideN.png
			if (JFile::exists($thumb_bak)) {
				if (!JFile::move($thumb_bak, $img_path.DS.'thumb_slide'.$slide_num.'.png')) {
					$error = JText::_('Cannot restore image file') . ': ' . $thumb_bak;			
				}
			}

			if ($error > 0) {
				break;
			}
		}
		
		// generation of method's response JSON string
		return $msg . (($error === 0)?('"1"}'):('"0", "error":"'.$error.'"}'));
	}

	/**
	 * JSON string generator method (for AJAX purposes)
	 *
	 * @access public
	 * @param	mixed	$slide reference to a Cu3erSlide JTable object / slide ID
	 * @param	object	$slidedefault reference to a Cu3erSlideDefault JTable object
	 * @return	string	JSON string
	 */
	function generateJSON(&$slide, &$slidedefault) {

		// including form field configuration file ($generate_slide_fields and $hidden_fields_default)
		require(JPATH_COMPONENT.DS.'helpers'.DS.'slide_fields.php');

		$slideshow_id = JRequest::getInt('slideshow_id');		
		// JSON data string		
		$data = "{";

		// checking slide variable type (integer if Cu3erDefaultView called it)
		if (is_numeric($slide)) {

			$slide_id = $slide;		
			$slide = & JTable::getInstance('Cu3erSlide', 'Table');
			$slide->load($slide_id);
		}

		// setting the image folder of the slideshow
		$image_dir = JURI::root().(JComponentHelper::getParams('com_media')->get('image_path')).DS.'CU3ER'.DS.$slide->slideshow_id.DS;		
		$notChangeable = array('x', 'y', 'scaleX', 'scaleY', 'align_pos');
		foreach ($generate_slide_fields as $param => $query_var) {
			// if parameter ($generate_slide_fields) exists in the slide table and it's not null			
			if (isset($slide->$param) && $slide->$param !== null) {
				// image exception				
				if ($param == 'image' || $param == 'use_image') {
					if($param == 'use_image') {
						if (!isset($slide_id)) {
							$data .= "'{$query_var}':$('use_image').value,";
						} else {
							$data .= "'{$query_var}':'{$slide->$param}', ";
						}
					} else {
						if (!isset($slide_id)) {
							$data .= "'{$query_var}':isURL($('image').value)?$('image').value:'".$image_dir."'+$('image').value,";
						} else {
							$data .= "'{$query_var}':'{$image_dir}{$slide->$param}', ";						
						}
					}
				} else {				
					if(in_array($param, $notChangeable)) {
						$data .= "'{$query_var}':'{$slide->$param}', ";
					} else {
						$data .= "'{$query_var}':$('{$param}').value, ";
					}
				}
			// if parameter exists in the default table and it's not null			
			} elseif (isset($slidedefault->$param) && $slidedefault->$param !== null) {
				if (!isset($slide_id) || in_array(strtolower($param), $hidden_fields_default)) {				
					$data .= "'{$query_var}':'{$slidedefault->$param}', ";
				} else {
					$data .= "'{$query_var}':$('{$param}').value, ";
				}
			} else {
				$data .= "'{$query_var}':'0', ";	
			}
		}

		// adding more required parameters ($generate_slide_fields does not contain) 
		$data .= "'slide_id':'{$slide->id}', 'slideshow_id':'{$slide->slideshow_id}',";

		$data .= "}";

		return $data;
	}
	
	function hasJavaScript($path) {
		$rootDir = dirname(dirname(dirname(dirname(dirname(__FILE__)))));
		$tempPath = explode("/", $path);
		$delFlag = true;
		for($i =0; $i<sizeof($tempPath); $i++) {
			if($delFlag) {
				if($tempPath[$i] == 'images') {
					$delFlag = false;
				} else {
					unset($tempPath[$i]);
				}
			}
		}
		$realPath = $rootDir . '/' . implode('/', $tempPath);
		return is_dir($realPath . '/fallback');
	}
	
	function getFallbackPath($path) {
		$rootDir = dirname(dirname(dirname(dirname(dirname(__FILE__)))));
		$realPath = $rootDir . substr($path, (strpos($path, basename($rootDir)) + strlen(basename($rootDir)) ));
		return $realPath . '/fallback';
	}
	
	function generator($data) {
		header('Content-type: application/xml');
		$generator_URL = 'http://205.186.138.15/img/wpcu3er/generate_slide.php';
		return $this->callSlideGenerator($generator_URL, $data);
	}


}
