<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: view.html.php 2011-04-12 05:17:53 svn $
 * @author MADEBYPLAY
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport( 'joomla.application.component.view');

// Import CU3ER helper
jimport('joomla.application.component.helper');

class Cu3erViewSlideDefault extends JView {

	function display($tpl = null) {
		
		$model = & $this->getModel();
		$slides_model = & $this->getModel('slides');

		// setting JTable instances
		$default = $model->getData(JRequest::getInt('cid'));
		$slides = $slides_model->getData();
		$slideshow = $model->getData($default->slideshow_id, 'Cu3erSlideshow');

		JFilterOutput::objectHTMLSafe($default);

		// setting up toolbar buttons (at the right)
		JToolBarHelper::title(JText::_('Edit Slide Defaults'));
		JToolBarHelper::save();
		JToolBarHelper::apply();
		JToolBarHelper::custom('preview', 'preview.png','preview_f2.png', JText::_('Preview'), false);
		if($model->hasJavaScript($slideshow->images_folder)) {
			JToolBarHelper::custom('preview_js', 'preview.png','preview_f2.png', JText::_('Preview JS'), false);
		}
		JToolBarHelper::custom('slideshowSettings', 'config.png','config_f2.png', JText::_('Slideshow Settings'), false);
		JToolBarHelper::custom('slidesAndTransitions','copy.png','copy_f2.png', JText::_('Slides &amp; Transitions'), false);

		JToolBarHelper::cancel();

		// setting up submenu
		JSubMenuHelper::addEntry(JText::_('Slideshows'), 'index.php?option=com_cu3er&view=slideshows');		
		JSubMenuHelper::addEntry(JText::_('Slideshow Settings'), 'index.php?option=com_cu3er&view=slideshow&cid=' . $default->slideshow_id);
		JSubMenuHelper::addEntry(JText::_('Slides &amp; Transitions'), 'index.php?option=com_cu3er&view=slides&cid=' . $default->slideshow_id);
		
		require_once(JPATH_COMPONENT.DS.'helpers'.DS.'slide_fields.php');
		require_once(JPATH_COMPONENT.DS.'models'.DS.'slide.php');
		$is_js = ($model->hasJavaScript($slideshow->images_folder)) ? 'true' : 'false';
		// assigning variables to the template (tmpl/default.php)
		$this->assignRef('default', $default);
		$this->assignRef('hidden_fields', $hidden_fields_default);
		$this->assignRef('special_fields', $special_fields_default);
		$this->assignRef('field_groups', $field_groups_default);
		$this->assignRef('slideshow_id', $slideshow->id);

		$scriptAdded = false;
		$num = 0;

		// setting JSONArray string
		$json_array = $this->generateJSONArray($slides, $default);

		// SqueezeBox initializator script
		$js_str = <<<EOD

		window.addEvent('domready', function() {			

			// array of postable JSON strings (data for generate_slide.php)			
			JSONArray = {$json_array};

			SqueezeBox.initialize({ size: {x: {$slideshow->width}, y: {$slideshow->height}}});

			SqueezeBox.addEvent('onClose', function() {
				
				if($('task').value == 'preview_js') {				
					// fallback image restoring ajax call					
					var ar = new Ajax('index.php?option=com_cu3er&view=slide&task=restoreslide&tmpl=component', 
						{
							method: 'post',
							data: {
								'slideshow_id':$('slideshow_id').value,
							},

							onSuccess: function(resp) {
								eval('resp='+resp);					
								// displaying possible error message from the PHP response					
								if (resp.success != 1) {					
									alert(resp.error);								
								}							
							},
						}).request();
				}
			});			
		});
		var isJS = {$is_js};
EOD;
		$doc =& JFactory::getDocument();

		// adding SqueezeBox initializator script to the HTML header
		$doc->addScriptDeclaration($js_str);

		// adding mootools.js to the HTML header
		JHTML::_( 'behavior.modal' );	
	
		parent::display($tpl);
	}

	function generateJSONArray(&$slides, &$default) {
		$json_array_str = "[";

		$is_first = true;

		foreach ($slides as $slide) {
			$json_array_str .= ((!$is_first)?', ':'') . Cu3erModelSlide::generateJSON($slide->id, $default);
			$is_first = false;
		}
		
		return $json_array_str . ']';
	}	

}
?>